# scicat_sdk_py
This is the API for the SciCat Backend

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: api/v3
- Package version: 4.15.0
- Generator version: 7.14.0-SNAPSHOT
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.9+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/SciCatProject/scicat-backend-next.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/SciCatProject/scicat-backend-next.git`)

Then import the package:
```python
import scicat_sdk_py
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import scicat_sdk_py
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import scicat_sdk_py
from scicat_sdk_py.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = scicat_sdk_py.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with scicat_sdk_py.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = scicat_sdk_py.HealthApi(api_client)

    try:
        api_response = api_instance.health_controller_check_v3()
        print("The response of HealthApi->health_controller_check_v3:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling HealthApi->health_controller_check_v3: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*HealthApi* | [**health_controller_check_v3**](docs/HealthApi.md#health_controller_check_v3) | **GET** /api/v3/health | 
*AdminApi* | [**admin_controller_get_config_v3**](docs/AdminApi.md#admin_controller_get_config_v3) | **GET** /api/v3/admin/config | 
*AdminApi* | [**admin_controller_get_theme_v3**](docs/AdminApi.md#admin_controller_get_theme_v3) | **GET** /api/v3/admin/theme | 
*AttachmentsV4Api* | [**attachments_v4_controller_create_attachment_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_create_attachment_v4) | **POST** /api/v4/attachments | It creates a new attachment.
*AttachmentsV4Api* | [**attachments_v4_controller_find_all_public_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_find_all_public_v4) | **GET** /api/v4/attachments/public | It returns a list of attachments.
*AttachmentsV4Api* | [**attachments_v4_controller_find_all_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_find_all_v4) | **GET** /api/v4/attachments | It returns a list of attachments.
*AttachmentsV4Api* | [**attachments_v4_controller_find_one_and_update_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_find_one_and_update_v4) | **PATCH** /api/v4/attachments/{aid} | It updates the attachment.
*AttachmentsV4Api* | [**attachments_v4_controller_find_one_attachment_and_remove_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_find_one_attachment_and_remove_v4) | **DELETE** /api/v4/attachments/{aid} | It deletes the attachment.
*AttachmentsV4Api* | [**attachments_v4_controller_find_one_v4**](docs/AttachmentsV4Api.md#attachments_v4_controller_find_one_v4) | **GET** /api/v4/attachments/{aid} | It returns the attachment requested.
*AuthApi* | [**auth_controller_ldap_login_v3**](docs/AuthApi.md#auth_controller_ldap_login_v3) | **POST** /api/v3/auth/ldap | Endpoint to authenticate users through an ldap service.
*AuthApi* | [**auth_controller_login_callback_v3**](docs/AuthApi.md#auth_controller_login_callback_v3) | **GET** /api/v3/auth/oidc/callback | 
*AuthApi* | [**auth_controller_login_v3**](docs/AuthApi.md#auth_controller_login_v3) | **POST** /api/v3/auth/login | 
*AuthApi* | [**auth_controller_logout_v3**](docs/AuthApi.md#auth_controller_logout_v3) | **POST** /api/v3/auth/logout | It logs the current user out.
*AuthApi* | [**auth_controller_msad_login_v3**](docs/AuthApi.md#auth_controller_msad_login_v3) | **POST** /api/v3/auth/msad | Legacy endpoint to authenticate users through an ldap service.
*AuthApi* | [**auth_controller_oidc_login_v3**](docs/AuthApi.md#auth_controller_oidc_login_v3) | **GET** /api/v3/auth/oidc | 
*AuthApi* | [**auth_controller_whoami_v3**](docs/AuthApi.md#auth_controller_whoami_v3) | **GET** /api/v3/auth/whoami | 
*DatasetsApi* | [**datasets_controller_append_to_array_field_v3**](docs/DatasetsApi.md#datasets_controller_append_to_array_field_v3) | **POST** /api/v3/datasets/{pid}/appendToArrayField | It appends a new value to the specific field.
*DatasetsApi* | [**datasets_controller_count_v3**](docs/DatasetsApi.md#datasets_controller_count_v3) | **GET** /api/v3/datasets/count | It returns the number of datasets.
*DatasetsApi* | [**datasets_controller_create_attachment_v3**](docs/DatasetsApi.md#datasets_controller_create_attachment_v3) | **POST** /api/v3/datasets/{pid}/attachments | It creates a new attachement for the dataset specified.
*DatasetsApi* | [**datasets_controller_create_datablock_v3**](docs/DatasetsApi.md#datasets_controller_create_datablock_v3) | **POST** /api/v3/datasets/{pid}/datablocks | It creates a new datablock for the dataset specified.
*DatasetsApi* | [**datasets_controller_create_orig_datablock_v3**](docs/DatasetsApi.md#datasets_controller_create_orig_datablock_v3) | **POST** /api/v3/datasets/{pid}/origdatablocks | It creates a new origDatablock for the dataset specified.
*DatasetsApi* | [**datasets_controller_create_v3**](docs/DatasetsApi.md#datasets_controller_create_v3) | **POST** /api/v3/datasets | It creates a new dataset which can be a raw, derived or custom one.
*DatasetsApi* | [**datasets_controller_find_all_attachments_v3**](docs/DatasetsApi.md#datasets_controller_find_all_attachments_v3) | **GET** /api/v3/datasets/{pid}/attachments | It returns all the attachments for the dataset specified.
*DatasetsApi* | [**datasets_controller_find_all_datablocks_v3**](docs/DatasetsApi.md#datasets_controller_find_all_datablocks_v3) | **GET** /api/v3/datasets/{pid}/datablocks | It returns all the datablock for the dataset specified.
*DatasetsApi* | [**datasets_controller_find_all_orig_datablocks_v3**](docs/DatasetsApi.md#datasets_controller_find_all_orig_datablocks_v3) | **GET** /api/v3/datasets/{pid}/origdatablocks | It returns all the origDatablock for the dataset specified.
*DatasetsApi* | [**datasets_controller_find_all_v3**](docs/DatasetsApi.md#datasets_controller_find_all_v3) | **GET** /api/v3/datasets | It returns a list of datasets.
*DatasetsApi* | [**datasets_controller_find_by_id_and_delete_v3**](docs/DatasetsApi.md#datasets_controller_find_by_id_and_delete_v3) | **DELETE** /api/v3/datasets/{pid} | It deletes the dataset.
*DatasetsApi* | [**datasets_controller_find_by_id_and_replace_v3**](docs/DatasetsApi.md#datasets_controller_find_by_id_and_replace_v3) | **PUT** /api/v3/datasets/{pid} | It updates the dataset.
*DatasetsApi* | [**datasets_controller_find_by_id_and_update_v3**](docs/DatasetsApi.md#datasets_controller_find_by_id_and_update_v3) | **PATCH** /api/v3/datasets/{pid} | It partially updates the dataset.
*DatasetsApi* | [**datasets_controller_find_by_id_v3**](docs/DatasetsApi.md#datasets_controller_find_by_id_v3) | **GET** /api/v3/datasets/{pid} | 
*DatasetsApi* | [**datasets_controller_find_logbook_by_pid_v3**](docs/DatasetsApi.md#datasets_controller_find_logbook_by_pid_v3) | **GET** /api/v3/datasets/{pid}/logbook | Retrive logbook associated with dataset.
*DatasetsApi* | [**datasets_controller_find_one_attachment_and_remove_v3**](docs/DatasetsApi.md#datasets_controller_find_one_attachment_and_remove_v3) | **DELETE** /api/v3/datasets/{pid}/attachments/{aid} | It deletes the attachment from the dataset.
*DatasetsApi* | [**datasets_controller_find_one_attachment_and_update_v3**](docs/DatasetsApi.md#datasets_controller_find_one_attachment_and_update_v3) | **PUT** /api/v3/datasets/{pid}/attachments/{aid} | It updates the attachment specified for the dataset indicated.
*DatasetsApi* | [**datasets_controller_find_one_datablock_and_remove_v3**](docs/DatasetsApi.md#datasets_controller_find_one_datablock_and_remove_v3) | **DELETE** /api/v3/datasets/{pid}/datablocks/{did} | It deletes the datablock from the dataset.
*DatasetsApi* | [**datasets_controller_find_one_datablock_and_update_v3**](docs/DatasetsApi.md#datasets_controller_find_one_datablock_and_update_v3) | **PATCH** /api/v3/datasets/{pid}/datablocks/{did} | It updates the datablocks specified for the dataset indicated.
*DatasetsApi* | [**datasets_controller_find_one_orig_datablock_and_remove_v3**](docs/DatasetsApi.md#datasets_controller_find_one_orig_datablock_and_remove_v3) | **DELETE** /api/v3/datasets/{pid}/origdatablocks/{oid} | It deletes the origdatablock from the dataset.
*DatasetsApi* | [**datasets_controller_find_one_orig_datablock_and_update_v3**](docs/DatasetsApi.md#datasets_controller_find_one_orig_datablock_and_update_v3) | **PATCH** /api/v3/datasets/{pid}/origdatablocks/{oid} | It updates the origDatablocks specified for the dataset indicated.
*DatasetsApi* | [**datasets_controller_find_one_v3**](docs/DatasetsApi.md#datasets_controller_find_one_v3) | **GET** /api/v3/datasets/findOne | It returns the first dataset found.
*DatasetsApi* | [**datasets_controller_fullfacet_v3**](docs/DatasetsApi.md#datasets_controller_fullfacet_v3) | **GET** /api/v3/datasets/fullfacet | 
*DatasetsApi* | [**datasets_controller_fullquery_v3**](docs/DatasetsApi.md#datasets_controller_fullquery_v3) | **GET** /api/v3/datasets/fullquery | It returns a list of datasets matching the query provided.
*DatasetsApi* | [**datasets_controller_is_valid_v3**](docs/DatasetsApi.md#datasets_controller_is_valid_v3) | **POST** /api/v3/datasets/isValid | It validates the dataset provided as input.
*DatasetsApi* | [**datasets_controller_metadata_keys_v3**](docs/DatasetsApi.md#datasets_controller_metadata_keys_v3) | **GET** /api/v3/datasets/metadataKeys | It returns a list of metadata keys contained in the datasets matching the filter provided.
*DatasetsApi* | [**datasets_controller_orig_datablock_is_valid_v3**](docs/DatasetsApi.md#datasets_controller_orig_datablock_is_valid_v3) | **POST** /api/v3/datasets/{pid}/origdatablocks/isValid | It validates the origDatablock values passed.
*DatasetsApi* | [**datasets_controller_thumbnail_v3**](docs/DatasetsApi.md#datasets_controller_thumbnail_v3) | **GET** /api/v3/datasets/{pid}/thumbnail | It returns the thumbnail associated with the dataset.
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_count_public_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_count_public_v4) | **GET** /api/v4/datasets/public/count | It returns the number of public datasets.
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_find_all_public_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_find_all_public_v4) | **GET** /api/v4/datasets/public | It returns a list of public datasets.
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_find_by_id_public_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_find_by_id_public_v4) | **GET** /api/v4/datasets/public/{pid} | 
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_find_one_public_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_find_one_public_v4) | **GET** /api/v4/datasets/public/findOne | It returns the first public dataset found.
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_fullfacet_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_fullfacet_v4) | **GET** /api/v4/datasets/public/fullfacet | 
*DatasetsPublicV4Api* | [**datasets_public_v4_controller_public_metadata_keys_v4**](docs/DatasetsPublicV4Api.md#datasets_public_v4_controller_public_metadata_keys_v4) | **GET** /api/v4/datasets/public/metadataKeys | It returns a list of metadata keys contained in the public datasets matching the filter provided.
*DatasetsV4Api* | [**datasets_v4_controller_count_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_count_v4) | **GET** /api/v4/datasets/count | It returns the number of datasets.
*DatasetsV4Api* | [**datasets_v4_controller_create_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_create_v4) | **POST** /api/v4/datasets | It creates a new dataset. Type should be raw, derived or any of the customized types available in your instance
*DatasetsV4Api* | [**datasets_v4_controller_find_all_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_all_v4) | **GET** /api/v4/datasets | It returns a list of datasets.
*DatasetsV4Api* | [**datasets_v4_controller_find_by_id_and_delete_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_by_id_and_delete_v4) | **DELETE** /api/v4/datasets/{pid} | It deletes the dataset.
*DatasetsV4Api* | [**datasets_v4_controller_find_by_id_and_replace_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_by_id_and_replace_v4) | **PUT** /api/v4/datasets/{pid} | It updates the dataset.
*DatasetsV4Api* | [**datasets_v4_controller_find_by_id_and_update_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_by_id_and_update_v4) | **PATCH** /api/v4/datasets/{pid} | It partially updates the dataset.
*DatasetsV4Api* | [**datasets_v4_controller_find_by_id_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_by_id_v4) | **GET** /api/v4/datasets/{pid} | 
*DatasetsV4Api* | [**datasets_v4_controller_find_logbook_by_pid_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_logbook_by_pid_v4) | **GET** /api/v4/datasets/{pid}/logbook | Retrive logbook associated with dataset.
*DatasetsV4Api* | [**datasets_v4_controller_find_one_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_find_one_v4) | **GET** /api/v4/datasets/findOne | It returns the first dataset found.
*DatasetsV4Api* | [**datasets_v4_controller_fullfacet_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_fullfacet_v4) | **GET** /api/v4/datasets/fullfacet | 
*DatasetsV4Api* | [**datasets_v4_controller_is_valid_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_is_valid_v4) | **POST** /api/v4/datasets/isValid | It validates the dataset provided as input.
*DatasetsV4Api* | [**datasets_v4_controller_metadata_keys_v4**](docs/DatasetsV4Api.md#datasets_v4_controller_metadata_keys_v4) | **GET** /api/v4/datasets/metadataKeys | It returns a list of metadata keys contained in the datasets matching the filter provided.
*ElasticSearchApi* | [**elastic_search_service_controller_create_index_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_create_index_v3) | **POST** /api/v3/elastic-search/create-index | 
*ElasticSearchApi* | [**elastic_search_service_controller_delete_index_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_delete_index_v3) | **POST** /api/v3/elastic-search/delete-index | 
*ElasticSearchApi* | [**elastic_search_service_controller_fetch_es_results_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_fetch_es_results_v3) | **POST** /api/v3/elastic-search/search | 
*ElasticSearchApi* | [**elastic_search_service_controller_get_index_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_get_index_v3) | **GET** /api/v3/elastic-search/get-index | 
*ElasticSearchApi* | [**elastic_search_service_controller_sync_database_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_sync_database_v3) | **POST** /api/v3/elastic-search/sync-database | 
*ElasticSearchApi* | [**elastic_search_service_controller_update_index_v3**](docs/ElasticSearchApi.md#elastic_search_service_controller_update_index_v3) | **POST** /api/v3/elastic-search/update-index | 
*InstrumentsApi* | [**instruments_controller_count_v3**](docs/InstrumentsApi.md#instruments_controller_count_v3) | **GET** /api/v3/instruments/count | 
*InstrumentsApi* | [**instruments_controller_create_v3**](docs/InstrumentsApi.md#instruments_controller_create_v3) | **POST** /api/v3/instruments | 
*InstrumentsApi* | [**instruments_controller_find_all_v3**](docs/InstrumentsApi.md#instruments_controller_find_all_v3) | **GET** /api/v3/instruments | 
*InstrumentsApi* | [**instruments_controller_find_by_id_v3**](docs/InstrumentsApi.md#instruments_controller_find_by_id_v3) | **GET** /api/v3/instruments/{id} | 
*InstrumentsApi* | [**instruments_controller_find_one_v3**](docs/InstrumentsApi.md#instruments_controller_find_one_v3) | **GET** /api/v3/instruments/findOne | It returns the first instrument found.
*InstrumentsApi* | [**instruments_controller_remove_v3**](docs/InstrumentsApi.md#instruments_controller_remove_v3) | **DELETE** /api/v3/instruments/{id} | 
*InstrumentsApi* | [**instruments_controller_update_v3**](docs/InstrumentsApi.md#instruments_controller_update_v3) | **PATCH** /api/v3/instruments/{id} | 
*JobsApi* | [**jobs_controller_create_v3_v3**](docs/JobsApi.md#jobs_controller_create_v3_v3) | **POST** /api/v3/jobs | It creates a new job.
*JobsApi* | [**jobs_controller_create_v4_v4**](docs/JobsApi.md#jobs_controller_create_v4_v4) | **POST** /api/v4/jobs | It creates a new job.
*JobsApi* | [**jobs_controller_find_all_v3_v3**](docs/JobsApi.md#jobs_controller_find_all_v3_v3) | **GET** /api/v3/jobs | It returns a list of jobs.
*JobsApi* | [**jobs_controller_find_all_v4_v4**](docs/JobsApi.md#jobs_controller_find_all_v4_v4) | **GET** /api/v4/jobs | It returns a list of jobs.
*JobsApi* | [**jobs_controller_find_one_v3_v3**](docs/JobsApi.md#jobs_controller_find_one_v3_v3) | **GET** /api/v3/jobs/{id} | It returns the requested job.
*JobsApi* | [**jobs_controller_find_one_v4_v4**](docs/JobsApi.md#jobs_controller_find_one_v4_v4) | **GET** /api/v4/jobs/{id} | It returns the requested job.
*JobsApi* | [**jobs_controller_full_facet_v3_v3**](docs/JobsApi.md#jobs_controller_full_facet_v3_v3) | **GET** /api/v3/jobs/fullfacet | It returns a list of job facets matching the filter provided.
*JobsApi* | [**jobs_controller_full_facet_v4_v4**](docs/JobsApi.md#jobs_controller_full_facet_v4_v4) | **GET** /api/v4/jobs/fullfacet | It returns a list of job facets matching the filter provided.
*JobsApi* | [**jobs_controller_full_query_v3_v3**](docs/JobsApi.md#jobs_controller_full_query_v3_v3) | **GET** /api/v3/jobs/fullquery | It returns a list of jobs matching the query provided.
*JobsApi* | [**jobs_controller_full_query_v4_v4**](docs/JobsApi.md#jobs_controller_full_query_v4_v4) | **GET** /api/v4/jobs/fullquery | It returns a list of jobs matching the query provided.
*JobsApi* | [**jobs_controller_remove_v3_v3**](docs/JobsApi.md#jobs_controller_remove_v3_v3) | **DELETE** /api/v3/jobs/{id} | It deletes the requested job.
*JobsApi* | [**jobs_controller_remove_v4_v4**](docs/JobsApi.md#jobs_controller_remove_v4_v4) | **DELETE** /api/v4/jobs/{id} | It deletes the requested job.
*JobsApi* | [**jobs_controller_update_v3_v3**](docs/JobsApi.md#jobs_controller_update_v3_v3) | **PATCH** /api/v3/jobs/{id} | It updates an existing job.
*JobsApi* | [**jobs_controller_update_v4_v4**](docs/JobsApi.md#jobs_controller_update_v4_v4) | **PATCH** /api/v4/jobs/{id} | It updates an existing job.
*LogbooksApi* | [**logbooks_controller_find_all_v3**](docs/LogbooksApi.md#logbooks_controller_find_all_v3) | **GET** /api/v3/logbooks | 
*LogbooksApi* | [**logbooks_controller_find_by_name_v3**](docs/LogbooksApi.md#logbooks_controller_find_by_name_v3) | **GET** /api/v3/logbooks/{name} | 
*OrigdatablocksApi* | [**orig_datablocks_controller_create_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_create_v3) | **POST** /api/v3/origdatablocks | It creates a new orig datablock for the specified dataset.
*OrigdatablocksApi* | [**orig_datablocks_controller_find_all_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_find_all_v3) | **GET** /api/v3/origdatablocks | It returns a list of orig datablocks.
*OrigdatablocksApi* | [**orig_datablocks_controller_find_by_id_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_find_by_id_v3) | **GET** /api/v3/origdatablocks/{id} | It retrieve the origdatablock.
*OrigdatablocksApi* | [**orig_datablocks_controller_fullfacet_files_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_fullfacet_files_v3) | **GET** /api/v3/origdatablocks/fullfacet/files | 
*OrigdatablocksApi* | [**orig_datablocks_controller_fullfacet_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_fullfacet_v3) | **GET** /api/v3/origdatablocks/fullfacet | 
*OrigdatablocksApi* | [**orig_datablocks_controller_fullquery_files_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_fullquery_files_v3) | **GET** /api/v3/origdatablocks/fullquery/files | 
*OrigdatablocksApi* | [**orig_datablocks_controller_fullquery_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_fullquery_v3) | **GET** /api/v3/origdatablocks/fullquery | 
*OrigdatablocksApi* | [**orig_datablocks_controller_is_valid_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_is_valid_v3) | **POST** /api/v3/origdatablocks/isValid | It validates the orig datablock provided as input.
*OrigdatablocksApi* | [**orig_datablocks_controller_remove_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_remove_v3) | **DELETE** /api/v3/origdatablocks/{id} | It deletes the origdatablock.
*OrigdatablocksApi* | [**orig_datablocks_controller_update_v3**](docs/OrigdatablocksApi.md#orig_datablocks_controller_update_v3) | **PATCH** /api/v3/origdatablocks/{id} | It updates the origdatablock.
*PoliciesApi* | [**policies_controller_count_v3**](docs/PoliciesApi.md#policies_controller_count_v3) | **GET** /api/v3/policies/count | 
*PoliciesApi* | [**policies_controller_create_v3**](docs/PoliciesApi.md#policies_controller_create_v3) | **POST** /api/v3/policies | 
*PoliciesApi* | [**policies_controller_find_all_v3**](docs/PoliciesApi.md#policies_controller_find_all_v3) | **GET** /api/v3/policies | 
*PoliciesApi* | [**policies_controller_find_one_v3**](docs/PoliciesApi.md#policies_controller_find_one_v3) | **GET** /api/v3/policies/{id} | 
*PoliciesApi* | [**policies_controller_remove_v3**](docs/PoliciesApi.md#policies_controller_remove_v3) | **DELETE** /api/v3/policies/{id} | 
*PoliciesApi* | [**policies_controller_update_v3**](docs/PoliciesApi.md#policies_controller_update_v3) | **PATCH** /api/v3/policies/{id} | 
*PoliciesApi* | [**policies_controller_update_where_v3**](docs/PoliciesApi.md#policies_controller_update_where_v3) | **POST** /api/v3/policies/updateWhere | 
*ProposalsApi* | [**proposals_controller_count_v3**](docs/ProposalsApi.md#proposals_controller_count_v3) | **GET** /api/v3/proposals/count | It returns the number of proposals.
*ProposalsApi* | [**proposals_controller_create_attachment_v3**](docs/ProposalsApi.md#proposals_controller_create_attachment_v3) | **POST** /api/v3/proposals/{pid}/attachments | It creates a new attachement for the proposal specified.
*ProposalsApi* | [**proposals_controller_create_v3**](docs/ProposalsApi.md#proposals_controller_create_v3) | **POST** /api/v3/proposals | It creates a new proposal.
*ProposalsApi* | [**proposals_controller_find_all_attachments_v3**](docs/ProposalsApi.md#proposals_controller_find_all_attachments_v3) | **GET** /api/v3/proposals/{pid}/attachments | It returns all the attachments for the proposal specified.
*ProposalsApi* | [**proposals_controller_find_all_datasets_v3**](docs/ProposalsApi.md#proposals_controller_find_all_datasets_v3) | **GET** /api/v3/proposals/{pid}/datasets | It returns all the datasets associated with the proposal indicated.
*ProposalsApi* | [**proposals_controller_find_all_v3**](docs/ProposalsApi.md#proposals_controller_find_all_v3) | **GET** /api/v3/proposals | It returns a list of proposals.
*ProposalsApi* | [**proposals_controller_find_by_id_access_v3**](docs/ProposalsApi.md#proposals_controller_find_by_id_access_v3) | **GET** /api/v3/proposals/{pid}/authorization | Check user access to a specific proposal.
*ProposalsApi* | [**proposals_controller_find_by_id_v3**](docs/ProposalsApi.md#proposals_controller_find_by_id_v3) | **GET** /api/v3/proposals/{pid} | It returns the proposal requested.
*ProposalsApi* | [**proposals_controller_find_one_attachment_and_remove_v3**](docs/ProposalsApi.md#proposals_controller_find_one_attachment_and_remove_v3) | **DELETE** /api/v3/proposals/{pid}/attachments/{aid} | It deletes the attachment from the proposal.
*ProposalsApi* | [**proposals_controller_find_one_attachment_and_update_v3**](docs/ProposalsApi.md#proposals_controller_find_one_attachment_and_update_v3) | **PATCH** /api/v3/proposals/{pid}/attachments/{aid} | It updates the attachment specified for the proposal indicated.
*ProposalsApi* | [**proposals_controller_fullfacet_v3**](docs/ProposalsApi.md#proposals_controller_fullfacet_v3) | **GET** /api/v3/proposals/fullfacet | It returns a list of proposal facets matching the filter provided.
*ProposalsApi* | [**proposals_controller_fullquery_v3**](docs/ProposalsApi.md#proposals_controller_fullquery_v3) | **GET** /api/v3/proposals/fullquery | It returns a list of proposals matching the query provided.
*ProposalsApi* | [**proposals_controller_is_valid_v3**](docs/ProposalsApi.md#proposals_controller_is_valid_v3) | **POST** /api/v3/proposals/isValid | It validates the proposal provided as input.
*ProposalsApi* | [**proposals_controller_remove_v3**](docs/ProposalsApi.md#proposals_controller_remove_v3) | **DELETE** /api/v3/proposals/{pid} | It deletes the proposal.
*ProposalsApi* | [**proposals_controller_update_v3**](docs/ProposalsApi.md#proposals_controller_update_v3) | **PATCH** /api/v3/proposals/{pid} | It updates the proposal.
*PublishedDataApi* | [**published_data_controller_count_v3**](docs/PublishedDataApi.md#published_data_controller_count_v3) | **GET** /api/v3/publisheddata/count | 
*PublishedDataApi* | [**published_data_controller_create_v3**](docs/PublishedDataApi.md#published_data_controller_create_v3) | **POST** /api/v3/publisheddata | 
*PublishedDataApi* | [**published_data_controller_find_all_v3**](docs/PublishedDataApi.md#published_data_controller_find_all_v3) | **GET** /api/v3/publisheddata | 
*PublishedDataApi* | [**published_data_controller_find_one_v3**](docs/PublishedDataApi.md#published_data_controller_find_one_v3) | **GET** /api/v3/publisheddata/{id} | It returns the published data requested.
*PublishedDataApi* | [**published_data_controller_form_populate_v3**](docs/PublishedDataApi.md#published_data_controller_form_populate_v3) | **GET** /api/v3/publisheddata/formpopulate | 
*PublishedDataApi* | [**published_data_controller_register_v3**](docs/PublishedDataApi.md#published_data_controller_register_v3) | **POST** /api/v3/publisheddata/{id}/register | 
*PublishedDataApi* | [**published_data_controller_remove_v3**](docs/PublishedDataApi.md#published_data_controller_remove_v3) | **DELETE** /api/v3/publisheddata/{id} | 
*PublishedDataApi* | [**published_data_controller_resync_v3**](docs/PublishedDataApi.md#published_data_controller_resync_v3) | **POST** /api/v3/publisheddata/{id}/resync | Edits published data.
*PublishedDataApi* | [**published_data_controller_update_v3**](docs/PublishedDataApi.md#published_data_controller_update_v3) | **PATCH** /api/v3/publisheddata/{id} | 
*SamplesApi* | [**samples_controller_count_v3**](docs/SamplesApi.md#samples_controller_count_v3) | **GET** /api/v3/samples/count | It returns a total count of samples
*SamplesApi* | [**samples_controller_create_attachments_v3**](docs/SamplesApi.md#samples_controller_create_attachments_v3) | **POST** /api/v3/samples/{id}/attachments | It creates a new attachment related with this sample.
*SamplesApi* | [**samples_controller_create_v3**](docs/SamplesApi.md#samples_controller_create_v3) | **POST** /api/v3/samples | It creates a new sample.
*SamplesApi* | [**samples_controller_find_all_attachments_v3**](docs/SamplesApi.md#samples_controller_find_all_attachments_v3) | **GET** /api/v3/samples/{id}/attachments | It returns the attachments related to a specific sample.
*SamplesApi* | [**samples_controller_find_all_datasets_v3**](docs/SamplesApi.md#samples_controller_find_all_datasets_v3) | **GET** /api/v3/samples/{id}/datasets | It returns the datasets related to a specific sample.
*SamplesApi* | [**samples_controller_find_all_v3**](docs/SamplesApi.md#samples_controller_find_all_v3) | **GET** /api/v3/samples | It returns a list of samples
*SamplesApi* | [**samples_controller_find_by_id_access_v3**](docs/SamplesApi.md#samples_controller_find_by_id_access_v3) | **GET** /api/v3/samples/{id}/authorization | 
*SamplesApi* | [**samples_controller_find_by_id_v3**](docs/SamplesApi.md#samples_controller_find_by_id_v3) | **GET** /api/v3/samples/{id} | It returns the sample requested.
*SamplesApi* | [**samples_controller_find_one_attachment_and_remove_v3**](docs/SamplesApi.md#samples_controller_find_one_attachment_and_remove_v3) | **DELETE** /api/v3/samples/{id}/attachments/{fk} | It deletes the attachment related to a specific sample.
*SamplesApi* | [**samples_controller_find_one_attachment_v3**](docs/SamplesApi.md#samples_controller_find_one_attachment_v3) | **GET** /api/v3/samples/{id}/attachments/{fk} | It returns the attachment related to a specific sample.
*SamplesApi* | [**samples_controller_find_one_v3**](docs/SamplesApi.md#samples_controller_find_one_v3) | **GET** /api/v3/samples/findOne | It returns a sample matching the query provided.
*SamplesApi* | [**samples_controller_fullquery_v3**](docs/SamplesApi.md#samples_controller_fullquery_v3) | **GET** /api/v3/samples/fullquery | It returns a list of samples matching the query provided.
*SamplesApi* | [**samples_controller_metadata_keys_v3**](docs/SamplesApi.md#samples_controller_metadata_keys_v3) | **GET** /api/v3/samples/metadataKeys | It returns a list of sample metadata keys matching the query provided.
*SamplesApi* | [**samples_controller_remove_v3**](docs/SamplesApi.md#samples_controller_remove_v3) | **DELETE** /api/v3/samples/{id} | It deletes the sample.
*SamplesApi* | [**samples_controller_update_v3**](docs/SamplesApi.md#samples_controller_update_v3) | **PATCH** /api/v3/samples/{id} | It updates the sample.
*UserIdentitiesApi* | [**user_identities_controller_find_one_v3**](docs/UserIdentitiesApi.md#user_identities_controller_find_one_v3) | **GET** /api/v3/useridentities/findOne | 
*UserIdentitiesApi* | [**user_identities_controller_is_valid_email_v3**](docs/UserIdentitiesApi.md#user_identities_controller_is_valid_email_v3) | **GET** /api/v3/useridentities/isValidEmail | It returns true if the emailed passed in is linked to any registered users
*UsersApi* | [**users_controller_can_user_create_dataset_v3**](docs/UsersApi.md#users_controller_can_user_create_dataset_v3) | **GET** /api/v3/users/{id}/authorization/dataset/create | 
*UsersApi* | [**users_controller_create_custom_jwtv3**](docs/UsersApi.md#users_controller_create_custom_jwtv3) | **POST** /api/v3/users/{id}/jwt | It creates a new jwt token for the user specified.
*UsersApi* | [**users_controller_create_settings_v3**](docs/UsersApi.md#users_controller_create_settings_v3) | **POST** /api/v3/users/{id}/settings | 
*UsersApi* | [**users_controller_find_by_id_v3**](docs/UsersApi.md#users_controller_find_by_id_v3) | **GET** /api/v3/users/{id} | 
*UsersApi* | [**users_controller_get_my_settings_v3**](docs/UsersApi.md#users_controller_get_my_settings_v3) | **GET** /api/v3/users/my/settings | 
*UsersApi* | [**users_controller_get_my_user_identity_v3**](docs/UsersApi.md#users_controller_get_my_user_identity_v3) | **GET** /api/v3/users/my/identity | 
*UsersApi* | [**users_controller_get_my_user_v3**](docs/UsersApi.md#users_controller_get_my_user_v3) | **GET** /api/v3/users/my/self | Returns the information of the user currently logged in.
*UsersApi* | [**users_controller_get_settings_v3**](docs/UsersApi.md#users_controller_get_settings_v3) | **GET** /api/v3/users/{id}/settings | 
*UsersApi* | [**users_controller_get_user_identity_v3**](docs/UsersApi.md#users_controller_get_user_identity_v3) | **GET** /api/v3/users/{id}/userIdentity | 
*UsersApi* | [**users_controller_get_user_jwtv3**](docs/UsersApi.md#users_controller_get_user_jwtv3) | **POST** /api/v3/users/jwt | It creates a new jwt token.
*UsersApi* | [**users_controller_login_v3**](docs/UsersApi.md#users_controller_login_v3) | **POST** /api/v3/users/login | This endpoint is deprecated and will be removed soon. Use /auth/login instead
*UsersApi* | [**users_controller_logout_v3**](docs/UsersApi.md#users_controller_logout_v3) | **POST** /api/v3/users/logout | It logs the current user out.
*UsersApi* | [**users_controller_patch_external_settings_v3**](docs/UsersApi.md#users_controller_patch_external_settings_v3) | **PATCH** /api/v3/users/{id}/settings/external | 
*UsersApi* | [**users_controller_patch_settings_v3**](docs/UsersApi.md#users_controller_patch_settings_v3) | **PATCH** /api/v3/users/{id}/settings | 
*UsersApi* | [**users_controller_remove_settings_v3**](docs/UsersApi.md#users_controller_remove_settings_v3) | **DELETE** /api/v3/users/{id}/settings | 
*UsersApi* | [**users_controller_update_settings_v3**](docs/UsersApi.md#users_controller_update_settings_v3) | **PUT** /api/v3/users/{id}/settings | 


## Documentation For Models

 - [Attachment](docs/Attachment.md)
 - [AttachmentRelationshipClass](docs/AttachmentRelationshipClass.md)
 - [CountApiResponse](docs/CountApiResponse.md)
 - [CreateAttachmentV3Dto](docs/CreateAttachmentV3Dto.md)
 - [CreateAttachmentV4Dto](docs/CreateAttachmentV4Dto.md)
 - [CreateCustomJwt](docs/CreateCustomJwt.md)
 - [CreateDatasetDatablockDto](docs/CreateDatasetDatablockDto.md)
 - [CreateDatasetDto](docs/CreateDatasetDto.md)
 - [CreateDatasetOrigDatablockDto](docs/CreateDatasetOrigDatablockDto.md)
 - [CreateDerivedDatasetObsoleteDto](docs/CreateDerivedDatasetObsoleteDto.md)
 - [CreateInstrumentDto](docs/CreateInstrumentDto.md)
 - [CreateJobDto](docs/CreateJobDto.md)
 - [CreateJobDtoV3](docs/CreateJobDtoV3.md)
 - [CreateMeasurementPeriodDto](docs/CreateMeasurementPeriodDto.md)
 - [CreateOrigDatablockDto](docs/CreateOrigDatablockDto.md)
 - [CreatePolicyDto](docs/CreatePolicyDto.md)
 - [CreateProposalDto](docs/CreateProposalDto.md)
 - [CreatePublishedDataDto](docs/CreatePublishedDataDto.md)
 - [CreateRawDatasetObsoleteDto](docs/CreateRawDatasetObsoleteDto.md)
 - [CreateSampleDto](docs/CreateSampleDto.md)
 - [CreateSubAttachmentV3Dto](docs/CreateSubAttachmentV3Dto.md)
 - [CreateUserJWT](docs/CreateUserJWT.md)
 - [CreateUserSettingsDto](docs/CreateUserSettingsDto.md)
 - [CredentialsDto](docs/CredentialsDto.md)
 - [DataFile](docs/DataFile.md)
 - [Datablock](docs/Datablock.md)
 - [DatasetClass](docs/DatasetClass.md)
 - [DatasetListDto](docs/DatasetListDto.md)
 - [DatasetsControllerCreateV3Request](docs/DatasetsControllerCreateV3Request.md)
 - [DatasetsControllerFindByIdAndReplaceV3Request](docs/DatasetsControllerFindByIdAndReplaceV3Request.md)
 - [DatasetsControllerFindByIdAndUpdateV3Request](docs/DatasetsControllerFindByIdAndUpdateV3Request.md)
 - [FindByIdAccessResponse](docs/FindByIdAccessResponse.md)
 - [FormPopulateData](docs/FormPopulateData.md)
 - [FullFacetFilters](docs/FullFacetFilters.md)
 - [FullFacetResponse](docs/FullFacetResponse.md)
 - [HealthControllerCheckV3200Response](docs/HealthControllerCheckV3200Response.md)
 - [HealthControllerCheckV3200ResponseInfoValue](docs/HealthControllerCheckV3200ResponseInfoValue.md)
 - [HealthControllerCheckV3503Response](docs/HealthControllerCheckV3503Response.md)
 - [HistoryClass](docs/HistoryClass.md)
 - [ICount](docs/ICount.md)
 - [Instrument](docs/Instrument.md)
 - [IsValidResponse](docs/IsValidResponse.md)
 - [JobClass](docs/JobClass.md)
 - [LifecycleClass](docs/LifecycleClass.md)
 - [Logbook](docs/Logbook.md)
 - [MeasurementPeriodClass](docs/MeasurementPeriodClass.md)
 - [OrigDatablock](docs/OrigDatablock.md)
 - [OutputAttachmentV3Dto](docs/OutputAttachmentV3Dto.md)
 - [OutputDatasetDto](docs/OutputDatasetDto.md)
 - [OutputDatasetObsoleteDto](docs/OutputDatasetObsoleteDto.md)
 - [OutputJobV3Dto](docs/OutputJobV3Dto.md)
 - [PartialUpdateAttachmentV3Dto](docs/PartialUpdateAttachmentV3Dto.md)
 - [PartialUpdateAttachmentV4Dto](docs/PartialUpdateAttachmentV4Dto.md)
 - [PartialUpdateDatablockDto](docs/PartialUpdateDatablockDto.md)
 - [PartialUpdateDatasetDto](docs/PartialUpdateDatasetDto.md)
 - [PartialUpdateDerivedDatasetObsoleteDto](docs/PartialUpdateDerivedDatasetObsoleteDto.md)
 - [PartialUpdateInstrumentDto](docs/PartialUpdateInstrumentDto.md)
 - [PartialUpdateOrigDatablockDto](docs/PartialUpdateOrigDatablockDto.md)
 - [PartialUpdatePolicyDto](docs/PartialUpdatePolicyDto.md)
 - [PartialUpdateProposalDto](docs/PartialUpdateProposalDto.md)
 - [PartialUpdatePublishedDataDto](docs/PartialUpdatePublishedDataDto.md)
 - [PartialUpdateRawDatasetObsoleteDto](docs/PartialUpdateRawDatasetObsoleteDto.md)
 - [PartialUpdateSampleDto](docs/PartialUpdateSampleDto.md)
 - [PartialUpdateUserSettingsDto](docs/PartialUpdateUserSettingsDto.md)
 - [Policy](docs/Policy.md)
 - [ProposalClass](docs/ProposalClass.md)
 - [ProposalCountFilters](docs/ProposalCountFilters.md)
 - [PublishedData](docs/PublishedData.md)
 - [RelationshipClass](docs/RelationshipClass.md)
 - [ReturnedAuthLoginDto](docs/ReturnedAuthLoginDto.md)
 - [ReturnedUserDto](docs/ReturnedUserDto.md)
 - [SampleClass](docs/SampleClass.md)
 - [SampleCountFilters](docs/SampleCountFilters.md)
 - [SampleWithAttachmentsAndDatasets](docs/SampleWithAttachmentsAndDatasets.md)
 - [SearchDto](docs/SearchDto.md)
 - [TechniqueClass](docs/TechniqueClass.md)
 - [TotalSets](docs/TotalSets.md)
 - [UpdateAttachmentV3Dto](docs/UpdateAttachmentV3Dto.md)
 - [UpdateDatasetDto](docs/UpdateDatasetDto.md)
 - [UpdateDerivedDatasetObsoleteDto](docs/UpdateDerivedDatasetObsoleteDto.md)
 - [UpdateJobDto](docs/UpdateJobDto.md)
 - [UpdateJobDtoV3](docs/UpdateJobDtoV3.md)
 - [UpdateOrigDatablockDto](docs/UpdateOrigDatablockDto.md)
 - [UpdatePolicyDto](docs/UpdatePolicyDto.md)
 - [UpdatePublishedDataDto](docs/UpdatePublishedDataDto.md)
 - [UpdateRawDatasetObsoleteDto](docs/UpdateRawDatasetObsoleteDto.md)
 - [UpdateWherePolicyDto](docs/UpdateWherePolicyDto.md)
 - [UserIdentity](docs/UserIdentity.md)
 - [UserProfile](docs/UserProfile.md)
 - [UserSettings](docs/UserSettings.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="bearer"></a>
### bearer

- **Type**: Bearer authentication (JWT)


## Author




